/*
 * Copyright
 *   2010 axYus - www.axyus.com
 *   2010 C. ESCOBAR - christel.escobar@axyus.com
 *
 * This file is part of XEMELIOS.
 *
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package fr.gouv.finances.dgfip.xemelios.controls.etatFrais.chorus;

import fr.gouv.finances.cp.xemelios.controls.AbstractUnitControl;
import fr.gouv.finances.cp.xemelios.controls.Anomalie;
import fr.gouv.finances.cp.xemelios.controls.IdGenerator;
import fr.gouv.finances.cp.xemelios.controls.Node;
import java.util.Hashtable;
import java.util.Stack;
import java.util.Vector;
import org.apache.log4j.Logger;
import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;

/**
 * L'élément InvoiceLine/LineExtensionAmount doit vérifier le format 9(19).9(4)
 *
 * @author Christel ESCOBAR
 */

public class M102 extends AbstractUnitControl {
    public static final String CTRL_ID = "CTL-M102" ;
    public static final transient String RESET_COUNTER_PATH = "EtatsFrais/Invoice/";
    public static final transient String INVOICEID_PATH = "EtatsFrais/Invoice/ID/";
    public static final transient String INVOICELINE_ID = "EtatsFrais/Invoice/InvoiceLine/ID/";
    public static final transient String INVOICELINE_PATH = "EtatsFrais/Invoice/InvoiceLine/";
    public static final transient String INVOICELINE_AMOUNT = "EtatsFrais/Invoice/InvoiceLine/LineExtensionAmount/";
    public static final transient String RETURN_ANOMALIES_PATH = RESET_COUNTER_PATH;

    private static final Logger logger = Logger.getLogger(M102.class);

    // pour stocker tous les paramètres d'execution des controles
    private Hashtable<String,Object> hParams;

    // pour stocker l'identifiant de l'invoice, on en a besoin pour générer l'anomalie
    private String invoiceId = "";
	private String ID_Invoice_Unique = "";
    private String invoiceLine_Id = "";
    
    private String amount = "";
    private String amount_NodeId = "";
    private boolean amount_present = false;
    
    // pour récupérer le texte des balises
    private Stack<StringBuffer> chars = new Stack<StringBuffer>();

    // pour stocker les anomalies que l'on génère
    Vector<Anomalie> anomalies = null;

    public void endDocument() throws SAXException { }

    public void startElement(String uri, String localName, String qName, Attributes atts, String xpath) throws SAXException {
        if(xpath.equals(RESET_COUNTER_PATH)) {           
            anomalies = new Vector<Anomalie>();
            invoiceId = "";   
            ID_Invoice_Unique = atts.getValue("ano:unique-id");
        } else if(xpath.equals(INVOICELINE_PATH)) {
        	invoiceLine_Id = "";
            amount_NodeId = "";
            amount_present = false;
        } else if(xpath.equals(INVOICELINE_AMOUNT)) {
            amount_NodeId = atts.getValue("ano:node-id");
            amount_present = true;
       }
        chars.push(new StringBuffer());
    }

    public Vector<Anomalie> endElement(String uri, String localName, String qName, String xpath) throws SAXException {
        if(xpath.equals(INVOICEID_PATH)) {
            invoiceId = chars.peek().toString();
        } else if(xpath.equals(INVOICELINE_ID)) {   
        	invoiceLine_Id = chars.peek().toString();
        } else if(xpath.equals(INVOICELINE_AMOUNT)) {   
        	amount = chars.peek().toString();
        } else if(xpath.equals(INVOICELINE_PATH)) {   
        
        	if (amount_present && !amount.matches("^[+-]{0,1}[0-9]{1,19}[.][0-9]{1,4}$")) {
        	
        			String anoId = IdGenerator.nextId();
                    Hashtable<String, Object> xslParams = new Hashtable<String, Object>();
                    xslParams.put("anoId", anoId);
                    xslParams.put("presentation","src");
                    String libelleLien = "Invoice "+invoiceId;
                    String path = "@ano:unique-id='" + ID_Invoice_Unique + "'";  // le XPath qui permettra de retrouver le
                    // on reconstitue le message
                    String message = getDocumentModel().getControlById(CTRL_ID).getMessage().getHtmlContent();
                    message = message.replace("#INVOICE_ID#", invoiceId);
                    message = message.replace("#INVOICE_LINE_ID#", invoiceLine_Id);
                    Anomalie ano = new Anomalie(anoId,
                            getDocumentModel().getControlById(CTRL_ID),
                            getDocumentModel().getDocumentId(),
                            "EtatFrais",
                            "invoice",
                            invoiceId,
                            localName,  // l'élément en anomalie est bien Invoice
                            libelleLien,
                            message,
                            getDocumentModel().getControlById(CTRL_ID).getRegle().getHtmlContent(),
                            getDocumentModel().getControlById(CTRL_ID).getSeverity(),
                            path,
                            xslParams);
                    ano.addNode(new Node(amount_NodeId));
                    anomalies.add(ano);
        	}
            chars.pop();
            return null;
        } else if(xpath.equals(RETURN_ANOMALIES_PATH)) {
        	chars.pop();
            return anomalies;
        }
        chars.pop();
        return null;
    }

    public void characters(char[] ch, int start, int length, String xpath) throws SAXException {
        // on met les caractères lus dans la pile
        chars.peek().append(ch, start, length);
    }

    public void ignorableWhitespace(char[] ch, int start, int length, String xpath) throws SAXException { }

    public void processingInstruction(String target, String data, String xpath) throws SAXException { }

    public void skippedEntity(String name, String xpath) throws SAXException { }

    public void setParameters(Hashtable<String, Object> params) {
        this.hParams=params;
    }

    public void setDocumentLocator(Locator locator) { }

    public void startDocument() throws SAXException { }

    public void startPrefixMapping(String prefix, String uri, String xpath) throws SAXException { }

    public void endPrefixMapping(String prefix, String xpath) throws SAXException { }
}
